## ufo-filters 0.14.1%2Bdfsg1

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

#{{{ Sources
set(ufofilter_SRCS
    ufo-average-task.c
    ufo-backproject-task.c
    ufo-bin-task.c
    ufo-binarize-task.c
    ufo-blur-task.c
    ufo-buffer-task.c
    ufo-calculate-task.c
    ufo-clip-task.c
    ufo-crop-task.c
    ufo-cut-task.c
    ufo-cut-sinogram-task.c
    ufo-center-of-rotation-task.c
    ufo-concatenate-result-task.c
    ufo-contrast-task.c
    ufo-correlate-stacks-task.c
    ufo-dfi-sinc-task.c
    ufo-denoise-task.c
    ufo-detect-edge-task.c
    ufo-rescale-task.c
    ufo-dummy-data-task.c
    ufo-dump-ring-task.c
    ufo-duplicate-task.c
    ufo-filter-task.c
    ufo-flatten-task.c
    ufo-flatten-inplace-task.c
    ufo-flat-field-correct-task.c
    ufo-fft-task.c
    ufo-fftmult-task.c
    ufo-filter-particle-task.c
    ufo-filter-stripes-task.c
    ufo-filter-stripes1d-task.c
    ufo-flip-task.c
    ufo-forwardproject-task.c
    ufo-get-dup-circ-task.c
    ufo-ifft-task.c
    ufo-interpolate-task.c
    ufo-interpolate-stream-task.c
    ufo-lamino-backproject-task.c
    ufo-loop-task.c
    ufo-map-slice-task.c
    ufo-measure-sharpness-task.c
    ufo-median-filter-task.c
    ufo-memory-in-task.c
    ufo-memory-out-task.c
    ufo-merge-task.c
    ufo-metaballs-task.c
    ufo-monitor-task.c
    ufo-null-task.c
    ufo-opencl-task.c
    ufo-ordfilt-task.c
    ufo-pad-task.c
    ufo-polar-coordinates-task.c
    ufo-read-task.c
    ufo-reduce-task.c
    ufo-refeed-task.c
    ufo-remove-circle-task.c
    ufo-retrieve-phase-task.c
    ufo-ring-pattern-task.c
    ufo-ringwriter-task.c
    ufo-replicate-task.c
    ufo-rotate-task.c
    ufo-sleep-task.c
    ufo-slice-task.c
    ufo-stack-task.c
    ufo-stdin-task.c
    ufo-stitch-task.c
    ufo-transpose-task.c
    ufo-transpose-projections-task.c
    ufo-swap-quadrants-task.c
    ufo-subtract-task.c
    ufo-volume-render-task.c
    ufo-write-task.c
    ufo-zeropad-task.c
    )

set(ufoaux_SRCS
    ufo-priv.c)

set(read_aux_SRCS
    readers/ufo-reader.c
    readers/ufo-edf-reader.c
    readers/ufo-raw-reader.c)

set(write_aux_SRCS
    writers/ufo-writer.c
    writers/ufo-raw-writer.c)

set(stdout_aux_SRCS
    writers/ufo-writer.c)

set(filter_aux_SRCS
    common/ufo-fft.c)

set(fft_aux_SRCS
    common/ufo-fft.c)

set(ifft_aux_SRCS
    common/ufo-fft.c)

set(retrieve_phase_aux_SRCS
    common/ufo-fft.c)

set(lamino_backproject_aux_SRCS
    lamino-roi.c)

file(GLOB ufofilter_KERNELS "kernels/*.cl")
#}}}
#{{{ Variables
set(ufofilter_LIBS
    m
    ${UFO_LIBRARIES}
    ${OpenCL_LIBRARIES})

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99 -pedantic -Wall -Wextra -fPIC -Wno-unused-parameter -Wno-deprecated-declarations")

add_definitions(-D_FILE_OFFSET_BITS=64 -D_LARGE_FILES)
#}}}
#{{{ Dependency checks
find_package(TIFF)
find_package(HDF5 1.8)
find_package(JPEG)
find_package(OpenMP)

pkg_check_modules(UCA libuca>=1.2)
pkg_check_modules(LIBTIFF4 libtiff-4>=4.0.0)
pkg_check_modules(GSL gsl)
pkg_check_modules(CLFFT clFFT)
pkg_check_modules(CLBLAST clblast)
pkg_check_modules(PANGOCAIRO pangocairo)


if (OPENMP_FOUND)
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
endif ()

if (OpenCL_VERSION_MAJOR)
    if (${OpenCL_VERSION_MAJOR} GREATER 1 OR
        (${OpenCL_VERSION_MAJOR} EQUAL 1 AND ${OpenCL_VERSION_MINOR} GREATER 1))
        # We need OpenCL > 1.1 for clEnqueueFillBuffer.
        list(APPEND ufofilter_SRCS ufo-segment-task.c)
    endif ()
endif ()

if (TIFF_FOUND)
    list(APPEND read_aux_SRCS readers/ufo-tiff-reader.c)
    list(APPEND read_aux_LIBS ${TIFF_LIBRARIES})
    list(APPEND write_aux_SRCS writers/ufo-tiff-writer.c)
    list(APPEND write_aux_LIBS ${TIFF_LIBRARIES})
    include_directories(${TIFF_INCLUDE_DIRS})
    link_directories(${TIFF_LIBRARY_DIRS})
    set(HAVE_TIFF True)
elseif (LIBTIFF4_INCLUDE_DIRS AND LIBTIFF4_LIBRARIES)
    list(APPEND read_aux_SRCS readers/ufo-tiff-reader.c)
    list(APPEND read_aux_LIBS ${LIBTIFF4_LIBRARIES})
    list(APPEND write_aux_SRCS writers/ufo-tiff-writer.c)
    list(APPEND write_aux_LIBS ${LIBTIFF4_LIBRARIES})
    include_directories(${LIBTIFF4_INCLUDE_DIRS})
    link_directories(${LIBTIFF4_LIBRARY_DIRS})
    set(HAVE_TIFF True)
endif ()

if (JPEG_FOUND)
    list(APPEND write_aux_SRCS writers/ufo-jpeg-writer.c)
    list(APPEND write_aux_LIBS ${JPEG_LIBRARIES})
    include_directories(${JPEG_INCLUDE_DIRS})
    link_directories(${JPEG_LIBRARY_DIRS})
    set(HAVE_JPEG True)
endif ()

if (HDF5_FOUND)
    option(WITH_HDF5 "Use HDF5" ON)
    if (WITH_HDF5)
        # This hack is proudly presented by stupid CMake configure scripts and a
        # badly written libhdf5.
        find_path(MPI_INCLUDE_PATH NAMES mpi.h PATHS /usr/include /usr/include/mpich2 /usr/lib/openmpi/include)

        if (MPI_INCLUDE_PATH)
            include_directories(${MPI_INCLUDE_PATH})
        endif ()

        list(APPEND read_aux_SRCS readers/ufo-hdf5-reader.c common/hdf5.c)
        list(APPEND read_aux_LIBS ${HDF5_LIBRARIES})
        list(APPEND write_aux_SRCS writers/ufo-hdf5-writer.c common/hdf5.c)
        list(APPEND write_aux_LIBS ${HDF5_LIBRARIES})
        include_directories(${HDF5_INCLUDE_DIRS})
        link_directories(${HDF5_LIBRARY_DIRS})
    endif ()
endif ()

if (UCA_INCLUDE_DIRS AND UCA_LIBRARIES)
    list(APPEND ufofilter_SRCS ufo-camera-task.c)
    list(APPEND uca_aux_LIBS ${UCA_LIBRARIES})
    include_directories(${UCA_INCLUDE_DIRS})
    link_directories(${UCA_LIBRARY_DIRS})
endif ()

if (GSL_FOUND)
    include_directories(${GSL_INCLUDE_DIRS})
    list(APPEND measure_aux_LIBS ${GSL_LIBRARIES})
    list(APPEND ufofilter_SRCS ufo-measure-task.c)
endif ()

if (TARGET oclfft)
    option(WITH_OCLFFT "Use Apple FFT" ON)

    if (WITH_OCLFFT)
        list(APPEND fft_aux_LIBS oclfft)
        list(APPEND ifft_aux_LIBS oclfft)
        list(APPEND retrieve_phase_aux_LIBS oclfft)
        list(APPEND filter_aux_LIBS oclfft)
        set(HAVE_AMD OFF)
    endif ()
endif ()

if (CLFFT_FOUND)
    option(WITH_CLFFT "Use AMD clFFT" ON)

    if (WITH_CLFFT)
        include_directories(${CLFFT_INCLUDE_DIRS})
        list(APPEND fft_aux_LIBS ${CLFFT_LIBRARIES})
        list(APPEND ifft_aux_LIBS ${CLFFT_LIBRARIES})
        list(APPEND retrieve_phase_aux_LIBS ${CLFFT_LIBRARIES})
        list(APPEND filter_aux_LIBS ${CLFFT_LIBRARIES})
        set(HAVE_AMD ON)
    endif ()
endif ()

if (CLBLAST_FOUND)
    include_directories(${CLBLAST_INCLUDE_DIRS})
    list(APPEND ufofilter_SRCS ufo-gemm-task.c)
    list(APPEND gemm_aux_LIBS ${CLBLAST_LIBRARIES})
endif ()

if (PANGOCAIRO_FOUND)
    include_directories(${PANGOCAIRO_INCLUDE_DIRS})
    list(APPEND ufofilter_SRCS ufo-stamp-task.c)
    list(APPEND stamp_aux_LIBS ${PANGOCAIRO_LIBRARIES})
endif ()

#}}}
#{{{ Plugin targets
include_directories(${CMAKE_CURRENT_BINARY_DIR}
                    ${CMAKE_CURRENT_SOURCE_DIR}
                    ${OpenCL_INCLUDE_DIRS}
                    ${UFO_INCLUDE_DIRS})

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.in
               ${CMAKE_CURRENT_BINARY_DIR}/config.h)

# build static auxiliary library first
add_library(ufoaux STATIC ${ufoaux_SRCS})

foreach(_src ${ufofilter_SRCS})
    # find plugin suffix
    string(REGEX REPLACE "ufo-([^ \\.]+)-task.*" "\\1" task "${_src}")

    # build string to get auxalleanous sources
    string(REPLACE "-" "_" _aux ${task})
    string(TOUPPER ${_aux} _aux_upper)

    # create an option name and add this to disable filters
    set(_aux_src "${_aux}_aux_SRCS")
    set(_aux_libs "${_aux}_aux_LIBS")

    string(REPLACE "-" "" _targetname ${task})
    set(target "ufofilter${_targetname}")

    # build single shared library per filter
    if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
        add_library(${target} MODULE ${_src} ${${_aux_src}})
    else()
        add_library(${target} SHARED ${_src} ${${_aux_src}})
    endif()

    target_link_libraries(${target} ${ufofilter_LIBS} ${${_aux_libs}} ufoaux)

    list(APPEND all_targets ${target})

    install(TARGETS ${target}
            ARCHIVE DESTINATION ${UFO_PLUGINDIR}
            LIBRARY DESTINATION ${UFO_PLUGINDIR})
endforeach()
#}}}
#{{{ Subdirectories
add_subdirectory(kernels)
#}}}

=== src/kernels/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

# make burst backprojection kernels
set(COMMON_TEMPLATE ${CMAKE_CURRENT_SOURCE_DIR}/templates/common.in)
set(DEFINITIONS ${CMAKE_CURRENT_SOURCE_DIR}/templates/definitions.in)
set(Z_TEMPLATE ${CMAKE_CURRENT_SOURCE_DIR}/templates/z_template.in)
set(LAMINO_TEMPLATE ${CMAKE_CURRENT_SOURCE_DIR}/templates/lamino_template.in)
set(CENTER_TEMPLATE ${CMAKE_CURRENT_SOURCE_DIR}/templates/center_template.in)
set(ROLL_TEMPLATE ${CMAKE_CURRENT_SOURCE_DIR}/templates/roll_template.in)
set(GENERATOR ${CMAKE_CURRENT_SOURCE_DIR}/tools/make_burst_kernels.py)
set(Z_KERNEL z_kernel.cl)
set(LAMINO_KERNEL lamino_kernel.cl)
set(CENTER_KERNEL center_kernel.cl)
set(ROLL_KERNEL roll_kernel.cl)

find_package(PythonInterp REQUIRED)

add_custom_command(
    OUTPUT ${Z_KERNEL} ${CENTER_KERNEL} ${LAMINO_KERNEL} ${ROLL_KERNEL}
    COMMAND ${PYTHON_EXECUTABLE} ${GENERATOR} ${Z_TEMPLATE} 1 2 4 8 16 > ${Z_KERNEL}
    COMMAND ${PYTHON_EXECUTABLE} ${GENERATOR} ${CENTER_TEMPLATE} 1 2 4 8 16 > ${CENTER_KERNEL}
    COMMAND ${PYTHON_EXECUTABLE} ${GENERATOR} ${LAMINO_TEMPLATE} 1 2 4 8 16 > ${LAMINO_KERNEL}
    COMMAND ${PYTHON_EXECUTABLE} ${GENERATOR} ${ROLL_TEMPLATE} 1 2 4 8 16 > ${ROLL_KERNEL}
    DEPENDS ${GENERATOR} ${COMMON_TEMPLATE} ${DEFINITIONS} ${Z_TEMPLATE} ${CENTER_TEMPLATE} ${LAMINO_TEMPLATE} ${ROLL_TEMPLATE}
    COMMENT "Generating burst backprojection kernels"
)

add_custom_target(burst ALL DEPENDS ${Z_KERNEL} ${CENTER_KERNEL} ${LAMINO_KERNEL} ${ROLL_KERNEL})

install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/${Z_KERNEL}
          ${CMAKE_CURRENT_BINARY_DIR}/${CENTER_KERNEL}
          ${CMAKE_CURRENT_BINARY_DIR}/${LAMINO_KERNEL}
          ${CMAKE_CURRENT_BINARY_DIR}/${ROLL_KERNEL}
    DESTINATION ${UFO_KERNELDIR}
)

# copy kernels
file(GLOB ufofilter_KERNELS "*.cl")

foreach(_kernel ${ufofilter_KERNELS})
    install(FILES ${_kernel} DESTINATION ${UFO_KERNELDIR})
endforeach()

=== contrib/sxc/src/CMakeLists.txt ===
##
## This file is part of ufo-serge filter set.
## Copyright (C) 2016 Serge Cohen
##
## This program is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program.  If not, see <http://www.gnu.org/licenses/>.
##
## Serge Cohen <serge.cohen@synchrotron-soleil.fr>
##

set(contrib_sxc_filter_SRCS
   ufo-med-mad-reject-2d-task.c
   ufo-med-mad-reject-task.c
   ufo-ocl-1liner-task.c
   ufo-stat-monitor-task.c
   )

set(contrib_sxc_aux_SRCS
    ufo-sxc-common.c)

file(GLOB contrib_sxc_filter_KERNELS "kernels/*.cl")

include(ConfigurePaths)
include(PkgConfigVars)
include(CheckCSourceCompiles)

configure_paths(CONTRIB_SXC_FILTERS)

find_package(OpenCL REQUIRED)
find_package(PkgConfig REQUIRED)

pkg_check_modules(UFO ufo>=${PKG_UFO_CORE_MIN_REQUIRED} REQUIRED)
pkg_check_variable(ufo plugindir)
pkg_check_variable(ufo kerneldir)

add_definitions("-std=c99 -Wall -fPIC")
add_definitions(-DG_LOG_DOMAIN="Ufo")

include_directories(${CMAKE_CURRENT_SOURCE_DIR}
                    ${OPENCL_INCLUDE_DIRS}
                    ${UFO_INCLUDE_DIRS})

link_directories(${UFO_LIBRARY_DIRS} ${OPENCL_LIBRARY_DIRS})

set(CMAKE_REQUIRED_INCLUDES ${OPENCL_INCLUDE_DIRS})

set(ufofilter_LIBS
    m
    ${UFO_LIBRARIES}
    ${OpenCL_LIBRARIES})

# build static auxiliary library first
add_library(contrib_sxc_aux STATIC ${contrib_sxc_aux_SRCS})

foreach(_src ${contrib_sxc_filter_SRCS})
    # find plugin suffix
    string(REGEX REPLACE "ufo-([^ \\.]+)-task.*" "\\1" task "${_src}")

    # build string to get miscalleanous sources
    string(REPLACE "-" "_" _misc ${task})
    string(TOUPPER ${_misc} _misc_upper)

    # create an option name and add this to disable filters
    set(_misc "${_misc}_misc_SRCS")

    string(REPLACE "-" "" _targetname ${task})
    set(target "ufofilter${_targetname}")

    # build single shared library per filter
    if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
        add_library(${target} MODULE ${_src} ${${_misc}})
    else()
        add_library(${target} SHARED ${_src} ${${_misc}})
    endif()

    target_link_libraries(${target} ${ufofilter_LIBS} ${${_aux_libs}} contrib_sxc_aux)

    list(APPEND all_targets ${target})

    install(TARGETS ${target}
            ARCHIVE DESTINATION ${UFO_PLUGINDIR}
            LIBRARY DESTINATION ${UFO_PLUGINDIR})
endforeach()


# copy kernels
foreach(_kernel ${contrib_sxc_filter_KERNELS})
    install(FILES ${_kernel} DESTINATION ${UFO_KERNELDIR})
endforeach()

## ufo-filters 0.13.0+dfsg1

=== debian/changelog ===
ufo-filters (0.13.0+dfsg1-1) unstable; urgency=medium

  * New upstream release.

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Wed, 25 Jan 2017 18:39:58 +0100

ufo-filters (0.12.0+dfsg1-1) unstable; urgency=low

  * Initial release (Closes: #844196)

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Sun, 27 Nov 2016 09:07:17 +0100

=== debian/control ===
Source: ufo-filters
Maintainer: Picca Frédéric-Emmanuel <picca@debian.org>
Section: libs
Priority: extra
Build-Depends: debhelper (>= 10),
               cmake,
               libclfft-dev,
               libglib2.0-dev,
               libgsl0-dev | libgsl-dev,
               libhdf5-dev,
               libtiff-dev,
               libufo-dev (>= 0.12.0),
               ocl-icd-opencl-dev,
               python-sphinx
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debian-pan/packages/ufo-filters.git
Vcs-Git: https://anonscm.debian.org/git/debian-pan/packages/ufo-filters.git
Homepage: http://ufo.kit.edu/

Package: ufo-filters
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         ufo-filters-data (= ${source:Version})
Description: Set of plugins for ufo-core - runtime
 The UFO data processing framework is a C library suited to build
 general purpose streams data processing on heterogeneous
 architectures such as CPUs, GPUs or clusters. It is extensively used
 at the Karlsruhe Institute of Technology for Ultra-fast X-ray Imaging
 (radiography, tomography and laminography).
 .
 This package contains `average', `backproject', `bin', `blur', `buffer',
 `calculate', `camera', `clip', `contrast', `crop', `denoise', `duplicate',
 `fftmult', `fft', `filter', `flatten', `flip', `forwardproject', `gemm',
 `ifft', `interpolate', `loop', `measure', `merge', `metaballs', `monitor',
 `null', `opencl', `ordfilt', `pad', `read', `reduce', `refeed', `replicate',
 `rescale', `ringwriter', `sleep', `slice', `stack', `stdin', `stdout',
 `subtract', `transpose', `write' and `zeropad' plugins

Package: ufo-filters-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends},
         ${sphinxdoc:Depends},
         libjs-mathjax,
Description: Library for high-performance, GPU-based computing - documentation
 The UFO data processing framework is a C library suited to build
 general purpose streams data processing on heterogeneous
 architectures such as CPUs, GPUs or clusters. It is extensively used
 at the Karlsruhe Institute of Technology for Ultra-fast X-ray Imaging
 (radiography, tomography and laminography).
 .
 This package provides the documentation for the plugins

Package: ufo-filters-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Library for high-performance, GPU-based computing - data
 The UFO data processing framework is a C library suited to build
 general purpose streams data processing on heterogeneous
 architectures such as CPUs, GPUs or clusters. It is extensively used
 at the Karlsruhe Institute of Technology for Ultra-fast X-ray Imaging
 (radiography, tomography and laminography).
 .
 This package provides the OpenCL kernel files for the plugins

## ufo-filters 0.14.1%2Bdfsg1

=== debian/changelog ===
ufo-filters (0.14.1+dfsg1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add upstream fix for FTBFS with glibc 2.25. (Closes: #882955)

 -- Adrian Bunk <bunk@debian.org>  Tue, 26 Dec 2017 23:03:53 +0200

ufo-filters (0.14.1+dfsg1-1) unstable; urgency=medium

  * New upstream release.

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Fri, 13 Oct 2017 18:39:58 +0200

ufo-filters (0.14.0+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * d/control
    - Bump Standard-Version 4.1.1 (extra -> optional)
    - Added Suggests: ufo-filters-doc (Closes: #847624)
    - Switched from python-sphinx to python3-sphinx.
    - Added python dependency which is now mandatory.

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Sun, 08 Oct 2017 10:46:25 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: ufo-filters
 Maintainer: Picca Frédéric-Emmanuel <picca@debian.org>
 Section: libs
-Priority: extra
+Priority: optional
 Build-Depends: debhelper (>= 10),
                cmake,
                libclfft-dev,
@@ -11,8 +11,9 @@
                libtiff-dev,
                libufo-dev (>= 0.12.0),
                ocl-icd-opencl-dev,
-               python-sphinx
-Standards-Version: 3.9.8
+               python,
+               python3-sphinx
+Standards-Version: 4.1.1
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-pan/packages/ufo-filters.git
 Vcs-Git: https://anonscm.debian.org/git/debian-pan/packages/ufo-filters.git
 Homepage: http://ufo.kit.edu/
@@ -23,6 +24,7 @@
 Depends: ${misc:Depends},
          ${shlibs:Depends},
          ufo-filters-data (= ${source:Version})
+Suggests: ufo-filters-doc
 Description: Set of plugins for ufo-core - runtime
  The UFO data processing framework is a C library suited to build
  general purpose streams data processing on heterogeneous

## ufo-filters 0.14.1+dfsg1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

if (POLICY CMP0046)
cmake_policy(SET CMP0046 OLD)
endif ()

if (POLICY CMP0053)
cmake_policy(SET CMP0053 OLD)
endif ()

if (POLICY CMP0054)
cmake_policy(SET CMP0054 OLD)
endif ()

project(ufo C)

set(TARNAME "ufo-filters")

set(UFO_FILTERS_VERSION_MAJOR "0")
set(UFO_FILTERS_VERSION_MINOR "14")
set(UFO_FILTERS_VERSION_PATCH "1")
set(UFO_FILTERS_VERSION_STRING_LONG "${UFO_FILTERS_VERSION_MAJOR}.${UFO_FILTERS_VERSION_MINOR}.${UFO_FILTERS_VERSION_PATCH}")
set(UFO_FILTERS_VERSION_STRING_SHORT "${UFO_FILTERS_VERSION_MAJOR}.${UFO_FILTERS_VERSION_MINOR}")

set(UFO_DESCRIPTION "UFO good filters")
set(UFO_DESCRIPTION_SUMMARY "UFO good filters")

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/common/cmake")

if (APPLE)
    set(CMAKE_MACOSX_RPATH      "ON")
    set(CMAKE_INSTALL_RPATH     "${CMAKE_INSTALL_PREFIX}/lib")
endif()

#{{{ Variables and Options
include(GNUInstallDirs)
include(PkgConfigVars)

set(PKG_UFO_CORE_MIN_REQUIRED "0.12")
# Backprojection burst mode, must be one of 1, 2, 4, 8, 16
set(BP_BURST "16" CACHE STRING "Number of projections processed in one pass")

option(WITH_PROFILING "Enable profiling" OFF)

if (WITH_PROFILING)
    add_definitions("-pg")
    set(CMAKE_C_FLAGS "-pg")
endif ()

option(WITH_CONTRIB "Enable contrib filters" OFF)
#}}}
#{{{ Common dependencies
find_package(OpenCL REQUIRED)
find_package(PkgConfig REQUIRED)

pkg_check_modules(UFO ufo>=${PKG_UFO_CORE_MIN_REQUIRED} REQUIRED)

pkg_check_variable(ufo plugindir)
pkg_check_variable(ufo kerneldir)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/deps/oclfft)

link_directories(${UFO_LIBRARY_DIRS})
#}}}
#{{{ Global definitions
add_definitions("-Wall -Wextra -fPIC")
add_definitions(-DG_LOG_DOMAIN="Ufo")

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99")

if (CMAKE_COMPILER_IS_GNUCC OR ("${CMAKE_C_COMPILER_ID}" STREQUAL "Clang"))
    add_definitions("-Wno-unused-parameter")
endif ()
#}}}
#{{{ Subdirectories
add_subdirectory(docs)
add_subdirectory(deps)
add_subdirectory(src)
if (WITH_CONTRIB)
    add_subdirectory(contrib)
endif ()
#}}}

=== meson_options.txt ===
option('lamino_backproject_burst_mode',
       type: 'combo',
       choices: ['1', '2', '4', '8', '16'],
       value: '16')

=== contrib/CMakeLists.txt ===

## This file is part of ufo-serge filter set.
## Copyright (C) 2016 Serge Cohen
##
## This program is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program.  If not, see <http://www.gnu.org/licenses/>.
##
## Serge Cohen <serge.cohen@synchrotron-soleil.fr>
##

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

add_subdirectory(sxc)

=== contrib/sxc/CMakeLists.txt ===

## This file is part of ufo-serge filter set.
## Copyright (C) 2016 Serge Cohen
##
## This program is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program.  If not, see <http://www.gnu.org/licenses/>.
##
## Serge Cohen <serge.cohen@synchrotron-soleil.fr>
##

set(PKG_UFO_CORE_MIN_REQUIRED "0.6")

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

add_subdirectory(src)

=== debian/changelog ===
ufo-filters (0.14.1+dfsg1-3) unstable; urgency=medium

  [ Alexandre Marie ]
  * Created salsa-ci.yml file to run CI tests.
  * Started python2 removal in debian/control file.
  * Closes: #938744
  
  [ Frédéric Picca ]
  * Use debhelper-compat instead of debian/compat.

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Sun, 08 Dec 2019 20:45:17 +0100

ufo-filters (0.14.1+dfsg1-2) unstable; urgency=medium

  * Team upload

  [ Adrian Bunk ]
  * Add upstream fix for FTBFS with Sphinx 1.8. (Closes: #918852)

  [ Andreas Tille ]
  * debhelper 12
  * Standards-Version: 4.3.0
  * Remove trailing whitespace in debian/changelog
  * Lintian-override for non-issue since the not excluded file does not harm

 -- Andreas Tille <tille@debian.org>  Wed, 20 Feb 2019 17:02:52 +0100

=== debian/control ===
--- 
+++ 
@@ -2,20 +2,20 @@
 Maintainer: Picca Frédéric-Emmanuel <picca@debian.org>
 Section: libs
 Priority: optional
-Build-Depends: debhelper (>= 10),
+Build-Depends: debhelper-compat (= 12),
                cmake,
                libclfft-dev,
                libglib2.0-dev,
                libgsl0-dev | libgsl-dev,
                libhdf5-dev,
                libtiff-dev,
-               libufo-dev (>= 0.12.0),
+               libufo-dev,
                ocl-icd-opencl-dev,
-               python,
+               python3,
                python3-sphinx
-Standards-Version: 4.1.1
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-pan/packages/ufo-filters.git
-Vcs-Git: https://anonscm.debian.org/git/debian-pan/packages/ufo-filters.git
+Standards-Version: 4.4.1
+Vcs-Browser: https://salsa.debian.org/science-team/ufo-filters
+Vcs-Git: https://salsa.debian.org/science-team/ufo-filters.git
 Homepage: http://ufo.kit.edu/
 
 Package: ufo-filters
@@ -46,7 +46,7 @@
 Section: doc
 Depends: ${misc:Depends},
          ${sphinxdoc:Depends},
-         libjs-mathjax,
+         libjs-mathjax
 Description: Library for high-performance, GPU-based computing - documentation
  The UFO data processing framework is a C library suited to build
  general purpose streams data processing on heterogeneous

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1

override_dh_auto_configure:
	dh_auto_configure -- -DWITH_OCLFFT=OFF -DWITH_CONTRIB=ON

%:
	dh $@ --with sphinxdoc

override_dh_install:
	# ufo-filters
	dh_install -p ufo-filters usr/lib/*/ufo

	# ufo-filters-data
	dh_install -p ufo-filters-data usr/share/ufo

	# ufo-filters-doc
	dh_link -p ufo-filters-doc /usr/share/javascript/mathjax/MathJax.js /usr/share/doc/ufo-filters/html/_static/MathJax.js
	dh_install -p ufo-filters-doc obj-*/docs/manual/html usr/share/doc/ufo-filters/

=== debian/watch ===
version=4
opts="dversionmangle=s/\+dfsg\d*$//,repacksuffix=+dfsg1,\
     filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%ufo-filters-$1.tar.gz%" \
     https://github.com/ufo-kit/ufo-filters/tags \
     (?:.*?/)?v?(\d[\d.]*)\.tar\.gz

## ufo-filters 0.16.0.159.g483ce16

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,8 @@
 cmake_minimum_required(VERSION 2.8)
+
+if (POLICY CMP0018)
+cmake_policy(SET CMP0018 OLD)
+endif ()
 
 if (POLICY CMP0046)
 cmake_policy(SET CMP0046 OLD)
@@ -12,13 +16,13 @@
 cmake_policy(SET CMP0054 OLD)
 endif ()
 
-project(ufo C)
+project(ufo C CXX)
 
 set(TARNAME "ufo-filters")
 
 set(UFO_FILTERS_VERSION_MAJOR "0")
-set(UFO_FILTERS_VERSION_MINOR "14")
-set(UFO_FILTERS_VERSION_PATCH "1")
+set(UFO_FILTERS_VERSION_MINOR "16")
+set(UFO_FILTERS_VERSION_PATCH "0")
 set(UFO_FILTERS_VERSION_STRING_LONG "${UFO_FILTERS_VERSION_MAJOR}.${UFO_FILTERS_VERSION_MINOR}.${UFO_FILTERS_VERSION_PATCH}")
 set(UFO_FILTERS_VERSION_STRING_SHORT "${UFO_FILTERS_VERSION_MAJOR}.${UFO_FILTERS_VERSION_MINOR}")
 
@@ -36,7 +40,7 @@
 include(GNUInstallDirs)
 include(PkgConfigVars)
 
-set(PKG_UFO_CORE_MIN_REQUIRED "0.12")
+set(PKG_UFO_CORE_MIN_REQUIRED "0.16")
 # Backprojection burst mode, must be one of 1, 2, 4, 8, 16
 set(BP_BURST "16" CACHE STRING "Number of projections processed in one pass")
 
@@ -66,16 +70,17 @@
 add_definitions("-Wall -Wextra -fPIC")
 add_definitions(-DG_LOG_DOMAIN="Ufo")
 
-set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99")
-
 if (CMAKE_COMPILER_IS_GNUCC OR ("${CMAKE_C_COMPILER_ID}" STREQUAL "Clang"))
     add_definitions("-Wno-unused-parameter")
 endif ()
 #}}}
 #{{{ Subdirectories
+enable_testing()
+
 add_subdirectory(docs)
 add_subdirectory(deps)
 add_subdirectory(src)
+add_subdirectory(tests)
 if (WITH_CONTRIB)
     add_subdirectory(contrib)
 endif ()

=== meson_options.txt ===
option('oclfft', type: 'boolean', value: true,
    description: 'Build Apple OpenCL FFT')

option('contrib_filters', type: 'boolean', value: false,
    description: 'Build contributed filters')

option('lamino_backproject_burst_mode',
    type: 'combo',
    choices: ['1', '2', '4', '8', '16'],
    value: '16')

=== contrib/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-
+##
 ## This file is part of ufo-serge filter set.
 ## Copyright (C) 2016 Serge Cohen
 ##
@@ -18,6 +18,90 @@
 ## Serge Cohen <serge.cohen@synchrotron-soleil.fr>
 ##
 
-list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
+set(contrib_sxc_filter_SRCS
+   ufo-backproject-irregular-task.c
+   ufo-bin-voxels-task.c
+   ufo-destrip-sinogram-task.c
+   ufo-med-mad-reject-2d-task.c
+   ufo-med-mad-reject-task.c
+   ufo-ocl-1liner-task.c
+   ufo-stat-monitor-task.c
+   )
 
-add_subdirectory(sxc)
+set(contrib_sxc_aux_SRCS
+    ufo-sxc-common.c)
+
+file(GLOB contrib_sxc_filter_KERNELS "kernels/*.cl")
+
+include(ConfigurePaths)
+include(PkgConfigVars)
+include(CheckCSourceCompiles)
+
+configure_paths(CONTRIB_SXC_FILTERS)
+
+find_package(OpenCL REQUIRED)
+find_package(PkgConfig REQUIRED)
+
+pkg_check_modules(UFO ufo>=${PKG_UFO_CORE_MIN_REQUIRED} REQUIRED)
+pkg_check_variable(ufo plugindir)
+pkg_check_variable(ufo kerneldir)
+
+add_definitions("-std=c99 -Wall -fPIC")
+add_definitions(-DG_LOG_DOMAIN="Ufo")
+
+include_directories(${CMAKE_CURRENT_SOURCE_DIR}
+                    ${CMAKE_CURRENT_BINARY_DIR}
+                    ${OPENCL_INCLUDE_DIRS}
+                    ${UFO_INCLUDE_DIRS})
+
+link_directories(${UFO_LIBRARY_DIRS} ${OPENCL_LIBRARY_DIRS})
+
+set(CMAKE_REQUIRED_INCLUDES ${OPENCL_INCLUDE_DIRS})
+
+set(ufofilter_LIBS
+    m
+    ${UFO_LIBRARIES}
+    ${OpenCL_LIBRARIES})
+
+set(CL_TARGET_OPENCL_VERSION "120")
+configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.in
+               ${CMAKE_CURRENT_BINARY_DIR}/config.h)
+
+# build static auxiliary library first
+add_library(contrib_sxc_aux STATIC ${contrib_sxc_aux_SRCS})
+
+foreach(_src ${contrib_sxc_filter_SRCS})
+    # find plugin suffix
+    string(REGEX REPLACE "ufo-([^ \\.]+)-task.*" "\\1" task "${_src}")
+
+    # build string to get auxalleanous sources
+    string(REPLACE "-" "_" _aux ${task})
+    string(TOUPPER ${_aux} _aux_upper)
+
+    # create an option name and add this to disable filters
+    set(_aux_src "${_aux}_aux_SRCS")
+    set(_aux_libs "${_aux}_aux_LIBS")
+
+    set(target "ufofilter${task}")
+
+    # build single shared library per filter
+    if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
+        add_library(${target} MODULE ${_src} ${${_aux_src}})
+    else()
+        add_library(${target} SHARED ${_src} ${${_aux_src}})
+    endif()
+
+    target_link_libraries(${target} ${ufofilter_LIBS} ${${_aux_libs}} contrib_sxc_aux)
+
+    list(APPEND all_targets ${target})
+
+    install(TARGETS ${target}
+            ARCHIVE DESTINATION ${UFO_PLUGINDIR}
+            LIBRARY DESTINATION ${UFO_PLUGINDIR})
+endforeach()
+
+
+# copy kernels
+foreach(_kernel ${contrib_sxc_filter_KERNELS})
+    install(FILES ${_kernel} DESTINATION ${UFO_KERNELDIR})
+endforeach()

=== docs/CMakeLists.txt ===
find_program(SPHINX sphinx-build PATHS /usr/local/bin /usr/bin)
mark_as_advanced(SPHINX)

# --- End-user manual ---------------------------------------------------------
if(SPHINX)
    option(WITH_MANUAL "Build user manual" ON)

    if (WITH_MANUAL)
        set(input_dir ${CMAKE_CURRENT_SOURCE_DIR})
        set(output_dir ${CMAKE_CURRENT_BINARY_DIR}/manual/html)

        file(GLOB_RECURSE sphinx_source ${input_dir}/*.rst)
        
        foreach(file ${sphinx_static})
            configure_file(${input_dir}/${file} ${output_dir}/${file} COPYONLY)
        endforeach()

        add_custom_command(OUTPUT ${output_dir}/index.html
            COMMAND ${SPHINX} -b html ${input_dir} ${output_dir}
            DEPENDS ${sphinx_source}
            COMMENT "Build Sphinx HTML")

        add_custom_target(manual ALL DEPENDS ${output_dir}/index.html)

        add_dependencies(manual ufo)
    endif()
endif()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -15,6 +15,7 @@
     ufo-cut-sinogram-task.c
     ufo-center-of-rotation-task.c
     ufo-concatenate-result-task.c
+    ufo-cone-beam-projection-weight-task.c
     ufo-contrast-task.c
     ufo-correlate-stacks-task.c
     ufo-dfi-sinc-task.c
@@ -25,6 +26,7 @@
     ufo-dump-ring-task.c
     ufo-duplicate-task.c
     ufo-filter-task.c
+    ufo-find-large-spots-task.c
     ufo-flatten-task.c
     ufo-flatten-inplace-task.c
     ufo-flat-field-correct-task.c
@@ -36,12 +38,18 @@
     ufo-flip-task.c
     ufo-forwardproject-task.c
     ufo-get-dup-circ-task.c
+    ufo-gradient-task.c
+    ufo-general-backproject-task.c
+    ufo-horizontal-interpolate-task.c
     ufo-ifft-task.c
     ufo-interpolate-task.c
     ufo-interpolate-stream-task.c
     ufo-lamino-backproject-task.c
     ufo-loop-task.c
+    ufo-map-color-task.c
     ufo-map-slice-task.c
+    ufo-mask-task.c
+    ufo-measure-task.c
     ufo-measure-sharpness-task.c
     ufo-median-filter-task.c
     ufo-memory-in-task.c
@@ -49,15 +57,19 @@
     ufo-merge-task.c
     ufo-metaballs-task.c
     ufo-monitor-task.c
+    ufo-non-local-means-task.c
     ufo-null-task.c
     ufo-opencl-task.c
+    ufo-opencl-reduce-task.c
     ufo-ordfilt-task.c
     ufo-pad-task.c
     ufo-polar-coordinates-task.c
+    ufo-power-spectrum-task.c
     ufo-read-task.c
     ufo-reduce-task.c
     ufo-refeed-task.c
     ufo-remove-circle-task.c
+    ufo-remove-outliers-task.c
     ufo-retrieve-phase-task.c
     ufo-ring-pattern-task.c
     ufo-ringwriter-task.c
@@ -65,9 +77,11 @@
     ufo-rotate-task.c
     ufo-sleep-task.c
     ufo-slice-task.c
+    ufo-sliding-stack-task.c
     ufo-stack-task.c
     ufo-stdin-task.c
     ufo-stitch-task.c
+    ufo-tile-task.c
     ufo-transpose-task.c
     ufo-transpose-projections-task.c
     ufo-swap-quadrants-task.c
@@ -107,6 +121,23 @@
 set(lamino_backproject_aux_SRCS
     lamino-roi.c)
 
+set(cone_beam_projection_weight_aux_SRCS
+    common/ufo-scarray.c)
+
+set(general_backproject_aux_SRCS
+    common/ufo-math.c
+    common/ufo-conebeam.c
+    common/ufo-scarray.c
+    common/ufo-ctgeometry.c)
+
+set(non_local_means_aux_SRCS
+    common/ufo-math.c
+    common/ufo-common.c)
+
+set(find_large_spots_aux_SRCS
+    common/ufo-math.c
+    common/ufo-common.c)
+
 file(GLOB ufofilter_KERNELS "kernels/*.cl")
 #}}}
 #{{{ Variables
@@ -115,7 +146,8 @@
     ${UFO_LIBRARIES}
     ${OpenCL_LIBRARIES})
 
-set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99 -pedantic -Wall -Wextra -fPIC -Wno-unused-parameter -Wno-deprecated-declarations")
+set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99 -pedantic -Wall -Wextra -fPIC -Wno-unused-parameter -Wno-deprecated-declarations")
+set(CL_TARGET_OPENCL_VERSION "120")
 
 add_definitions(-D_FILE_OFFSET_BITS=64 -D_LARGE_FILES)
 #}}}
@@ -124,13 +156,16 @@
 find_package(HDF5 1.8)
 find_package(JPEG)
 find_package(OpenMP)
+find_package(OpenCV)
 
 pkg_check_modules(UCA libuca>=1.2)
 pkg_check_modules(LIBTIFF4 libtiff-4>=4.0.0)
-pkg_check_modules(GSL gsl)
 pkg_check_modules(CLFFT clFFT)
 pkg_check_modules(CLBLAST clblast)
 pkg_check_modules(PANGOCAIRO pangocairo)
+pkg_check_modules(OPENCV opencv)
+pkg_check_modules(ZMQ libzmq)
+pkg_check_modules(JSON_GLIB json-glib-1.0)
 
 
 if (OPENMP_FOUND)
@@ -193,15 +228,9 @@
 
 if (UCA_INCLUDE_DIRS AND UCA_LIBRARIES)
     list(APPEND ufofilter_SRCS ufo-camera-task.c)
-    list(APPEND uca_aux_LIBS ${UCA_LIBRARIES})
+    list(APPEND camera_aux_LIBS ${UCA_LIBRARIES})
     include_directories(${UCA_INCLUDE_DIRS})
     link_directories(${UCA_LIBRARY_DIRS})
-endif ()
-
-if (GSL_FOUND)
-    include_directories(${GSL_INCLUDE_DIRS})
-    list(APPEND measure_aux_LIBS ${GSL_LIBRARIES})
-    list(APPEND ufofilter_SRCS ufo-measure-task.c)
 endif ()
 
 if (TARGET oclfft)
@@ -241,6 +270,26 @@
     list(APPEND stamp_aux_LIBS ${PANGOCAIRO_LIBRARIES})
 endif ()
 
+if (OpenCV_FOUND)
+    include_directories(${OpenCV_INCLUDE_DIRS})
+    list(APPEND ufofilter_SRCS ufo-cv-show-task.cpp)
+    list(APPEND cv_show_aux_LIBS ${OpenCV_LIBRARIES})
+    list(APPEND cv_show_aux_SRCS writers/ufo-writer.c)
+elseif (OPENCV_FOUND)
+    include_directories(${OPENCV_INCLUDE_DIRS})
+    list(APPEND ufofilter_SRCS ufo-cv-show-task.cpp)
+    list(APPEND cv_show_aux_LIBS ${OPENCV_LIBRARIES})
+    list(APPEND cv_show_aux_SRCS writers/ufo-writer.c)
+endif ()
+
+if (ZMQ_FOUND AND JSON_GLIB_FOUND)
+    include_directories(${ZMQ_INCLUDE_DIRS} ${JSON_GLIB_INCLUDE_DIRS})
+    link_directories(${ZMQ_LIBRARY_DIRS} ${JSON_GLIB_LIBRARY_DIRS})
+    list(APPEND ufofilter_SRCS ufo-zmq-pub-task.c ufo-zmq-sub-task.c)
+    list(APPEND zmq_sub_aux_LIBS ${ZMQ_LIBRARIES} ${JSON_GLIB_LIBRARIES})
+    list(APPEND zmq_pub_aux_LIBS ${ZMQ_LIBRARIES} ${JSON_GLIB_LIBRARIES})
+    list(APPEND zmq_sub_aux_LIBS ${ZMQ_LIBRARIES} ${JSON_GLIB_LIBRARIES})
+endif ()
 #}}}
 #{{{ Plugin targets
 include_directories(${CMAKE_CURRENT_BINARY_DIR}
@@ -266,8 +315,7 @@
     set(_aux_src "${_aux}_aux_SRCS")
     set(_aux_libs "${_aux}_aux_LIBS")
 
-    string(REPLACE "-" "" _targetname ${task})
-    set(target "ufofilter${_targetname}")
+    set(target "ufofilter${task}")
 
     # build single shared library per filter
     if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")

=== tests/CMakeLists.txt ===
find_program(BASH bash)

add_test(test_file_write_regression
         ${BASH} "${CMAKE_CURRENT_SOURCE_DIR}/test-file-write-regression.sh")

add_test(test_142
         ${BASH} "${CMAKE_CURRENT_SOURCE_DIR}/test-142.sh")

add_test(test_149
         ${BASH} "${CMAKE_CURRENT_SOURCE_DIR}/test-149.sh")

add_test(test_153
         ${BASH} "${CMAKE_CURRENT_SOURCE_DIR}/test-153.sh")

add_test(test_161
         ${BASH} "${CMAKE_CURRENT_SOURCE_DIR}/test-161.sh")

add_test(test_177
         ${BASH} "${CMAKE_CURRENT_SOURCE_DIR}/test-177.sh")

add_test(test_core_149
         ${BASH} "${CMAKE_CURRENT_SOURCE_DIR}/test-core-149.sh")

add_test(test_nlm
         ${BASH} "${CMAKE_CURRENT_SOURCE_DIR}/test-nlm.sh")

=== src/kernels/CMakeLists.txt ===
--- 
+++ 
@@ -7,20 +7,24 @@
 set(LAMINO_TEMPLATE ${CMAKE_CURRENT_SOURCE_DIR}/templates/lamino_template.in)
 set(CENTER_TEMPLATE ${CMAKE_CURRENT_SOURCE_DIR}/templates/center_template.in)
 set(ROLL_TEMPLATE ${CMAKE_CURRENT_SOURCE_DIR}/templates/roll_template.in)
+set(GENERAL_BP_DEFINITIONS templates/general_bp_definitions.in)
+set(GENERAL_BP_HEADER_SCALAR templates/general_bp_header_scalar.in)
+set(GENERAL_BP_HEADER_VECTOR templates/general_bp_header_vector.in)
+set(GENERAL_BP_BODY templates/general_bp_body.in)
 set(GENERATOR ${CMAKE_CURRENT_SOURCE_DIR}/tools/make_burst_kernels.py)
 set(Z_KERNEL z_kernel.cl)
 set(LAMINO_KERNEL lamino_kernel.cl)
 set(CENTER_KERNEL center_kernel.cl)
 set(ROLL_KERNEL roll_kernel.cl)
 
-find_package(PythonInterp REQUIRED)
+find_package (Python3 COMPONENTS Interpreter)
 
 add_custom_command(
     OUTPUT ${Z_KERNEL} ${CENTER_KERNEL} ${LAMINO_KERNEL} ${ROLL_KERNEL}
-    COMMAND ${PYTHON_EXECUTABLE} ${GENERATOR} ${Z_TEMPLATE} 1 2 4 8 16 > ${Z_KERNEL}
-    COMMAND ${PYTHON_EXECUTABLE} ${GENERATOR} ${CENTER_TEMPLATE} 1 2 4 8 16 > ${CENTER_KERNEL}
-    COMMAND ${PYTHON_EXECUTABLE} ${GENERATOR} ${LAMINO_TEMPLATE} 1 2 4 8 16 > ${LAMINO_KERNEL}
-    COMMAND ${PYTHON_EXECUTABLE} ${GENERATOR} ${ROLL_TEMPLATE} 1 2 4 8 16 > ${ROLL_KERNEL}
+    COMMAND ${Python3_EXECUTABLE} ${GENERATOR} ${Z_TEMPLATE} 1 2 4 8 16 > ${Z_KERNEL}
+    COMMAND ${Python3_EXECUTABLE} ${GENERATOR} ${CENTER_TEMPLATE} 1 2 4 8 16 > ${CENTER_KERNEL}
+    COMMAND ${Python3_EXECUTABLE} ${GENERATOR} ${LAMINO_TEMPLATE} 1 2 4 8 16 > ${LAMINO_KERNEL}
+    COMMAND ${Python3_EXECUTABLE} ${GENERATOR} ${ROLL_TEMPLATE} 1 2 4 8 16 > ${ROLL_KERNEL}
     DEPENDS ${GENERATOR} ${COMMON_TEMPLATE} ${DEFINITIONS} ${Z_TEMPLATE} ${CENTER_TEMPLATE} ${LAMINO_TEMPLATE} ${ROLL_TEMPLATE}
     COMMENT "Generating burst backprojection kernels"
 )
@@ -32,6 +36,10 @@
           ${CMAKE_CURRENT_BINARY_DIR}/${CENTER_KERNEL}
           ${CMAKE_CURRENT_BINARY_DIR}/${LAMINO_KERNEL}
           ${CMAKE_CURRENT_BINARY_DIR}/${ROLL_KERNEL}
+          ${CMAKE_CURRENT_SOURCE_DIR}/${GENERAL_BP_DEFINITIONS}
+          ${CMAKE_CURRENT_SOURCE_DIR}/${GENERAL_BP_HEADER_SCALAR}
+          ${CMAKE_CURRENT_SOURCE_DIR}/${GENERAL_BP_HEADER_VECTOR}
+          ${CMAKE_CURRENT_SOURCE_DIR}/${GENERAL_BP_BODY}
     DESTINATION ${UFO_KERNELDIR}
 )

=== debian/changelog ===
ufo-filters (0.16.0.159.g483ce16-1build5) plucky; urgency=medium

  * No-change rebuild against libhdf5-310

 -- Miriam España Acebal <miriam.espana@canonical.com>  Sun, 26 Jan 2025 11:09:33 +0000

ufo-filters (0.16.0.159.g483ce16-1build4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 19:28:05 +1100

ufo-filters (0.16.0.159.g483ce16-1build3) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 11 Mar 2024 23:44:32 +0000

ufo-filters (0.16.0.159.g483ce16-1build2) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 07:12:24 +0000

ufo-filters (0.16.0.159.g483ce16-1build1) lunar; urgency=medium

  * Rebuild against latest tiff

 -- Jeremy Bicha <jbicha@ubuntu.com>  Sat, 04 Feb 2023 07:34:52 -0500

ufo-filters (0.16.0.159.g483ce16-1) unstable; urgency=medium

  * uploaded to unstable

 -- Serge Cohen <serge1cohen@free.fr>  Wed, 14 Oct 2020 11:50:27 +0200

ufo-filters (0.16.0.159.g483ce16-1~exp2) experimental; urgency=medium

  * d/control: build depends libufo-dev >= 0.16

 -- Serge Cohen <serge1cohen@free.fr>  Fri, 02 Oct 2020 10:40:32 +0200

ufo-filters (0.16.0.159.g483ce16-1~exp1) experimental; urgency=medium

  [ Serge Cohen ]
  * Watching the correct upstream
  * New upstream version 0.16.0.159.g483ce16
  * d/control: Updated maintainer and uploader as ufo-core
  * d/salsa-ci.yml: -> recipes/debian.yml@salsa-ci-team/pipeline
  * Updated patch to satisfy newer orig
  * Corrected patch to new *.so naming conventions

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Thu, 01 Oct 2020 15:54:13 +0200

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,8 @@
 Source: ufo-filters
-Maintainer: Picca Frédéric-Emmanuel <picca@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Uploaders: Picca Frédéric-Emmanuel <picca@debian.org>,
+ Serge Cohen <serge1cohen@free.fr>
 Section: libs
 Priority: optional
 Build-Depends: debhelper-compat (= 12),
@@ -9,7 +12,7 @@
                libgsl0-dev | libgsl-dev,
                libhdf5-dev,
                libtiff-dev,
-               libufo-dev,
+               libufo-dev (>= 0.16),
                ocl-icd-opencl-dev,
                python3,
                python3-sphinx

=== debian/watch ===
version=4
opts="repacksuffix=+dfsg1,dversionmangle=s/@DEB_EXT@//,\
mode=git,pretty=describe,,uversionmangle=s/^v//,pgpmode=none" \
     https://git.chocolatnoir.net/tomography/ufo-filters.git \
     HEAD debian uupdate

## ufo-filters 0.16.0.267.gd856f91+dfsg1

=== debian/changelog ===
ufo-filters (0.16.0.267.gd856f91+dfsg1-1) unstable; urgency=medium

  [ Neil Williams ]
  * Update control to add Debian PaN maintainers

  [ Serge Cohen ]
  * New upstream version 0.16.0.172.g6f43afc+dfsg1
  * New upstream version 0.16.0.267.gd856f91+dfsg1
  * Incorporating many updates and addition from the github repository
  * Few bug corrections
  * Adding build-dep python3-sphinxcontrib.bibtex
  * Adding build-dep python3-sphinx-rtd-theme (and newer version of libufo1)

  [ Picca Frédéric-Emmanuel ]
  * lintian-brush  - compat -> 13
  * wrap-and-sort -ast
  * use dh-sequence-sphinxdoc
  * d/rules: dh_missing --list-missing

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Sun, 23 Mar 2025 08:27:15 +0100

=== debian/control ===
--- 
+++ 
@@ -1,22 +1,27 @@
 Source: ufo-filters
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
-Uploaders: Picca Frédéric-Emmanuel <picca@debian.org>,
- Serge Cohen <serge1cohen@free.fr>
+Maintainer: Debian PaN Maintainers <debian-pan-maintainers@alioth-lists.debian.net>
+Uploaders:
+ Picca Frédéric-Emmanuel <picca@debian.org>,
+ Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>,
+ Serge Cohen <serge1cohen@free.fr>,
 Section: libs
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
-               cmake,
-               libclfft-dev,
-               libglib2.0-dev,
-               libgsl0-dev | libgsl-dev,
-               libhdf5-dev,
-               libtiff-dev,
-               libufo-dev (>= 0.16),
-               ocl-icd-opencl-dev,
-               python3,
-               python3-sphinx
-Standards-Version: 4.4.1
+Build-Depends:
+ debhelper-compat (= 13),
+ dh-sequence-sphinxdoc <!nodoc>,
+ cmake,
+ libclfft-dev,
+ libglib2.0-dev,
+ libgsl0-dev | libgsl-dev,
+ libhdf5-dev,
+ libtiff-dev,
+ libufo-dev (>= 0.16),
+ ocl-icd-opencl-dev,
+ python3,
+ python3-sphinx,
+ python3-sphinx-rtd-theme,
+ python3-sphinxcontrib.bibtex,
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/science-team/ufo-filters
 Vcs-Git: https://salsa.debian.org/science-team/ufo-filters.git
 Homepage: http://ufo.kit.edu/
@@ -24,10 +29,12 @@
 Package: ufo-filters
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends},
-         ${shlibs:Depends},
-         ufo-filters-data (= ${source:Version})
-Suggests: ufo-filters-doc
+Depends:
+ ufo-filters-data (= ${source:Version}),
+ ${misc:Depends},
+ ${shlibs:Depends},
+Suggests:
+ ufo-filters-doc,
 Description: Set of plugins for ufo-core - runtime
  The UFO data processing framework is a C library suited to build
  general purpose streams data processing on heterogeneous
@@ -47,9 +54,10 @@
 Architecture: all
 Multi-Arch: foreign
 Section: doc
-Depends: ${misc:Depends},
-         ${sphinxdoc:Depends},
-         libjs-mathjax
+Depends:
+ libjs-mathjax,
+ ${misc:Depends},
+ ${sphinxdoc:Depends},
 Description: Library for high-performance, GPU-based computing - documentation
  The UFO data processing framework is a C library suited to build
  general purpose streams data processing on heterogeneous
@@ -62,7 +70,8 @@
 Package: ufo-filters-data
 Architecture: all
 Multi-Arch: foreign
-Depends: ${misc:Depends}
+Depends:
+ ${misc:Depends},
 Description: Library for high-performance, GPU-based computing - data
  The UFO data processing framework is a C library suited to build
  general purpose streams data processing on heterogeneous

## ufo-filters 0.17.0.75.gcb0bd5a%2Bdfsg1

=== debian/changelog ===
ufo-filters (0.17.0.75.gcb0bd5a+dfsg1-1) unstable; urgency=medium

  * Team Upload

  [Serge Cohen]
  * New upstream version 0.17.0.75.gcb0bd5a+dfsg1
  * Added a small reconstruction as autopkgtest
  * Added a OpenCL-less autopkg test
  * Updated the list of tasks/plugins present in the package
  * Correcting dependency of the tests to libufo-bin

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Thu, 01 May 2025 10:59:27 +0200
